% Funzione che converte i dati della cella di carico in dati di 
% forza mediante i valori di calibrazione.
% Il risultato è la matrico DatiLoad

function [DatiWireExtensometer,DatiNTCWireExtensometer,ErrWireExtensometerLink] = conv_grezziWEL(...
       WireExtensometer,NTCWireExtensometer,DCalWELTot,NodoWireExtensometerLink,...
       ErrWireExtensometerLink,WEL_NTC,rWEL,Tmax,Tmin,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'conv_grezziWEL function started';
fprintf(fileID,fmt,text);

[rA,cA] = size(WireExtensometer);
DatiWireExtensometer = zeros(rA,cA);
DatiNTCWireExtensometer = zeros(rA,cA);
for ii = 1:rWEL % numero di Wire Extensometer Link
    if strcmp(NodoWireExtensometerLink(ii,3),'4-20 mA')
        %% Conversione da mA a mm
        % Spacchetto i parametri di calibrazione
        a = DCalWELTot(ii,1);
        b = DCalWELTot(ii,2);
        c = DCalWELTot(ii,3);
        DatiWireExtensometer(:,ii) = a*(WireExtensometer(:,ii).^2)+b*WireExtensometer(:,ii)+c; % conversione
    elseif strcmp(NodoWireExtensometerLink(ii,3),'mV/V')
        %% Conversione da mV/V a mm
        % Spacchetto i parametri di calibrazione
        a = DCalWELTot(ii,1);
        b = DCalWELTot(ii,2);
        DatiWireExtensometer(:,ii) = a*WireExtensometer(:,ii)+b; % conversione
    elseif strcmp(NodoWireExtensometerLink(ii,3),'Hz')
        % Spacchetto i parametri di calibrazione
        GF = DCalELTot(ii,1);
        BF = DCalELTot(ii,2);
        digit = (WireExtensometer(:,ii).^2)*0.001; % Freq. ^2 *E-3
        DatiWireExtensometer(:,ii) = GF*BF*digit; % conversione in microEpsilon
    end
    A = 1.4051*10^(-3);
    B = 2.369*10^(-4);
    C = 1.019*10^(-7);
    if WEL_NTC(ii,1) == 1 % è presente il termometro
        R = NTCWireExtensometer(:,ii);
        [rN,~] = size(R);
        for n = 1:rN
            if R(n) <= 0
                if n > 1
                    R(n) = R(n-1);
                else
                    R(n) = 5000;
                end
                if ErrWireExtensometerLink(n,ii) == 0
                    ErrWireExtensometerLink(n,ii) = 0.5;
                end
            end
        end
        L = reallog(R);
        DatiNTCWireExtensometer(:,ii) = (1./(A + B*L + C*(L.^3))) -273.2; % conversione in gradi centigradi
        [rT,~] = size(DatiNTCWireExtensometer);
        for T = 1:rT
            if DatiNTCWireExtensometer(T,ii) > Tmax || DatiNTCWireExtensometer(T,ii) < Tmin
                if T == 1
                    DatiNTCWireExtensometer(T,ii) = DatiNTCWireExtensometer(T+1,ii);
                else
                    DatiNTCWireExtensometer(T,ii) = DatiNTCWireExtensometer(T-1,ii);
                end
                if ErrWireExtensometerLink(T,ii) == 0
                    ErrWireExtensometerLink(T,ii) = 0.5;
                end
            end
        end
    end
end

text = 'Calibrations of Wire Extensometer Link defined correctly. conv_grezziWEL function closed';
fprintf(fileID,fmt,text);
fclose(fileID);
end